unit hiODialog;

interface

uses Kol,Share,Debug;

type
  THIODialog = class(TDebug)
   private
    FOpenDialog:POpenSaveDialog;
   public
    _prop_StartDir:string;
    _prop_Filter:string;
    _prop_Title:string;
    _prop_filename:string;
    _prop_Select:procedure of object;
    _data_StartDir:THI_Event;
    _data_FileName:THI_Event;
    _event_onExecute:THI_Event;
    _event_onCancel:THI_Event;

    constructor Create;
    procedure _work_doExecute(var _Data:TData; Index:word);
    procedure _work_doStartDir(var _Data:TData; Index:word);
    procedure Simple;
    procedure Multi;
  end;

implementation

constructor THIODialog.Create;
begin
   inherited;
   FOpenDialog := nil;
end;

procedure THIODialog.Simple;
begin
  if not Assigned(FOpenDialog) then
    begin
      FOpenDialog := NewOpenSaveDialog(_prop_Title,_prop_StartDir,[]);
      FOpenDialog.WndOwner := ReadHandle;
      FOpenDialog.Filter := _prop_Filter;
      FOpendialog.Filename := _prop_filename;
    end;
  if FOpenDialog.Execute then
   _hi_OnEvent(_event_onExecute,FOpendialog.Filename)
  else _hi_OnEvent(_event_onCancel);
end;

procedure THIODialog.Multi;
var
  lst:PStrList;
  i:word;
begin
  if not Assigned(FOpenDialog) then
    begin
      FOpenDialog := NewOpenSaveDialog(_prop_Title,_prop_StartDir,[OSAllowMultiSelect,OSNoValidate]);
      FOpenDialog.WndOwner := ReadHandle;
      FOpenDialog.Filter := _prop_Filter;
      FOpendialog.Filename := _prop_filename;
    end;
  if FOpenDialog.Execute then
   begin
    lst := NewStrList;
    lst.Text := FOpendialog.Filename;
    if lst.Count = 1 then
     _hi_OnEvent(_event_onExecute,lst.items[0])
    else
     for i := 1 to lst.Count-1 do
      _hi_OnEvent(_event_onExecute,lst.items[0]+ '\' + lst.items[i]);
    lst.Free;
   end
  else _hi_OnEvent(_event_onCancel);
end;

procedure THIODialog._work_doExecute;
begin
   _prop_filename := ReadString(_Data,_data_FileName,_prop_filename);
   _prop_Select;
end;

procedure THIODialog._work_doStartDir;
begin
   _prop_StartDir := ReadString(_Data,_data_StartDir,_prop_StartDir);
end;

end.
